<script setup lang="tsx">
import { Form, FormSchema } from '@/components/Form'
import { useForm } from '@/hooks/web/useForm'
import { PropType, reactive, watch } from 'vue'
import { useValidator } from '@/hooks/web/useValidator'

const { required } = useValidator()

const props = defineProps({
  currentRow: {
    type: Object as PropType<any>,
    default: () => null
  },
  actionType: {
    type: String,
    default: 'add'
  }
})

const { formRegister, formMethods } = useForm()
const { setValues, getFormData, getElFormExpose } = formMethods

const formSchema = reactive<FormSchema[]>([
  {
    field: 'pkid',
    label: '主键',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'organcode',
    label: '归属机构',
    component: 'Select',
    componentProps: {
      
    },
  },
  {
    field: 'startDate',
    label: '申请查询的数据的开始日期',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'endDate',
    label: '申请查询的数据的结束日期',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'status',
    label: '申请状态',
    component: 'Select',
    componentProps: {
      
    },
  },
  {
    field: 'taskStartTime',
    label: '任务开始时间 ',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'taskEndTime',
    label: '任务结束时间',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'proposer',
    label: '申请人',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'applydate',
    label: '申请日期',
    component: 'DatePicker',
    componentProps: {
      type: 'daterange'
    },
  },
  {
    field: 'tableName',
    label: '申请生成的表',
    component: 'Select',
    componentProps: {
      
    },
  },
  {
    field: 'checkdepartment',
    label: '检验部门',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'organName',
    label: '机构名称',
    component: 'Input',
    componentProps: {
      
    },
  }
])

const rules = reactive({
  
})

const submit = async () => {
  const elForm = await getElFormExpose()
  const valid = await elForm?.validate().catch((err) => {
    console.log(err)
  })
  if (valid) {
    const formData = await getFormData()
    return formData
  }
}

watch(
  () => props.currentRow,
  (currentRow) => {
    if (!currentRow) return
    setValues(currentRow)
  },
  {
    deep: true,
    immediate: true
  }
)

defineExpose({
  submit
})
</script>

<template>
  <Form :rules="rules" @register="formRegister" :schema="formSchema" />
</template>

